<?php
/**
 * All-in-One WP Migration
 * Copyright (C) 2014-2018 ServMask Inc.
 *
 * Modified Copyright (C) 2025 Lead Connector
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if ( ! defined( 'ABSPATH' ) ) {
	die( 'Well Sir You Cannot Jump Here...haha' );
}

class Lcm_Import_Check_Compression {

	public static function execute( $params ) {

		// Read package.json file
		$handle = lcm_open( lcm_package_path( $params ), 'r' );

		// Parse package.json file
		$package = lcm_read( $handle, filesize( lcm_package_path( $params ) ) );
		$package = json_decode( $package, true );

		// Close handle
		lcm_close( $handle );

		// No compression provided
		if ( empty( $package['Compression']['Enabled'] ) || empty( $package['Compression']['Type'] ) ) {
			return $params;
		}

		// Check if server supports decompression
		if ( ! lcm_has_compression_type( $package['Compression']['Type'] ) ) {
			throw new Lcm_Import_Exception(
				wp_kses(
					sprintf(
						__(
							'Importing a compressed backup is not supported on this server. Please ensure <strong>%s</strong> extension is enabled.',
							'lc-migrator'
						),
						$package['Compression']['Type']
					),
					lcm_allowed_html_tags()
				)
			);
		}

		// Set progress
		Lcm_Status::info( __( 'Compressed backup detected. Compression will be handled automatically.', 'lc-migrator' ) );

		return $params;
	}
}
